               JOB  1401 Demonstration Assurance Program (DAP)
     *         CTL  6611
     ***************************************************************************
     *
     *     
     *     Provide a program to assure all components of the
     *     1401 System are operational. To be used by demonstrators
     *     before running demonstrations for Museum visitors. 
     *
     *     Program written in Autocoder
     *     Programmer:  Dan McInnis  
     *     Date:        April 16, 2007 
     *     
     ***************************************************************************
     *
               ORG  333
     *
     *
     *     Clear card reader storage and set word mark at location 1
     *
     BEGIN     CS   080
               SW   001
     *     Clear print storage           
     START     CS   332
               CS
               H                            *halt check printer,punch,tape
     * Read data card and test validity 
               CC   A                       *skip paper to channel 1 
               R                            *read data card
               B    RDERR,?                 *read error
     CLOOP     C    012,CDDATA              *compare 12 chars in card area
               BU   RDERR                   *branch if unequal -  read error 
               SW   *-14                    *set word mark for add
               A    @12@,*-19               *add 12 to card area address
               C    *-26,@084@              *compare address last full area
               BE   ENDRD                   *if last go to next compare
               CW   *-37                    *clear word mark from address
               B    CLOOP                   *go back to compare again
     ENDRD     SW   073                     *last area set word mark
               C    80,CDDATA-4             *compare 8 characters 
               BU   RDERR                   *branch if unequal- read error
               CW   073                     *clear word markread area
               MCW  080,280                 *move card data print area
               CC   K                       *double space
               W                            *print data
               CC   K                       *double space
               MCW  080,280                 *
               W                            *print data
               MCW  080,180                 *move data to punch area
               P                            *punch card 
               B    PCERR,!                 *punch error 
     TAPE      LCA  GRPMRK,081              *group mark to 81
               CS   299                     *clear print area
               LCA  GRPMRK,281              *group mark to 281
               RWD  1                       *rewind tape 1
               WT   1,001                   *write card area to tape 1
               BER  TPERR                   *if tape transmission error
               WT   1,001                   *write second record
               BER  TPERR                   *tape error
               BSP  1                       *backspace over last record
               BER  TPERR                   *tape error
               RT   1,201                   *read in first record
               BER  TPERR                   *tape error
               SW   001                     *SW READ AREA
               SW   201                     *SW PRINT AREA
               C    212,CDDATA              *compare first 12 chars
               BU   TPER1                   *tape error
               CC   J                       *double space 
               W                            *print tape data
               RWD  1                       *rewind tape
               CS   299                     *clear print area
               CC   A                       *skip paper to beginning
     END       H    START                   *restart program
     *  START OF ERROR HALT LOCATIONS 
     TPER1     H                            *DEBUG HALT INST
               MCW  @TAPE COMPARE ERROR@,260 *DEBUG INSTRUCTION
               W
               H    END
     PCERR     H    END
     RDERR     H    END
     PTERR     H    END
     TPERR     H    END
     *  START OF LITERAL LOCATION
     CDDATA    DCW  @0123456789SK@          *data 
     GRPMRK    DCW  @"@                     *group mark   
               END  BEGIN
